<?php

namespace App\Controllers;
use App\Models as M;

class Dogadjaji extends BaseController
{
    protected function prikaz2($page, $data) {
        $data['kategorije'] = (new M\KategorijaModel())->findAll();
        $data['gradovi'] = (new M\GradModel())->findAll();
        echo view("stranice/$page", $data);
    }
    
    public function index()
    {      
        return $this->prikaz2("index", [
        ]);
    }
    
    public function trazi() {
        $naslov = $this->request->getVar("naslov");
        $grad = $this->request->getVar("grad");
        $kategorija = $this->request->getVar("kategorija");
        $otkazan = $this->request->getVar("otkazan") == "da" ? 1 : 0;
        
        if ($naslov == "" && $grad == "" && $kategorija == null && $otkazan == 0) {
            return $this->prikaz2("index", [
                'poruka' => "Morate uneti bar 1 priterijum"
            ]);
        }
        
        $dogadjajModel = new M\DogadjajModel();
        $lokacijaModel = new M\LokacijaModel();
        
        $dogadjaji = $dogadjajModel->like('naziv', "%{$naslov}%");
        
        if ($kategorija != null) $dogadjaji = $dogadjaji->where("id_kategorije", $kategorija);
        
        if ($grad != "") {
            $sve_lokacije = $lokacijaModel->where('grad', $grad)->findAll();
            $lok_ids = [];
            foreach ($sve_lokacije as $lok) {
                array_push($lok_ids, $lok->id);
            }
            $dogadjaji->whereIn('id_lokacije', $lok_ids);
        }
        
        if ($otkazan) $dogadjaji = $dogadjaji->where('je_otkazan', 1)->findAll();
        else $dogadjaji = $dogadjaji->findAll();
        
        foreach($dogadjaji as $dog) {
            $lok =  $lokacijaModel->find($dog->id_lokacije);
            $dog->grad = $lok->grad;
            $dog->lokacija = $lok->naziv_lokacije;
            $dog->max_kapacitet = $lok->max_kapacitet;                   
        }
        
        
        if (empty($dogadjaji)) {
            return $this->prikaz2("index", [
                'poruka' => "Nijedan rezultat ne zadovoljava trazene kriterijume",
                'uneti_naziv' => $naslov,
                'uneti_grad' => $grad,
                'uneta_kategorija' => $kategorija,
                'uneto_otkazivanje' => $otkazan
            ]);
        }
        
        return $this->prikaz2("index", [
            'dogadjaji' => $dogadjaji,
            'uneti_naziv' => $naslov,
            'uneti_grad' => $grad,
            'uneta_kategorija' => $kategorija,
            'uneto_otkazivanje' => $otkazan
        ]);
        
    }
    
    public function ponisti() {
        return redirect()->to(site_url("Dogadjaji/index"));
    }
    
    
    public function prikaz() {
        $id = $this->request->getVar("id");
        $dog = (new M\DogadjajModel())->find($id);
        $lok = (new M\LokacijaModel())->find($dog->id_lokacije);
        return $this->prikaz2("prikaz", [
            'naziv' => $dog->naziv,
            'grad' => $lok->grad,
            'mesto'=> $lok->naziv_lokacije,
            'datum' => $dog->datum,
            'vreme' => $dog->vreme,
            'broj_zainteresovanih' => $dog->broj_interesenata,
            'ocena' => (rand(1, 5) / 10) * 10
            
        ]);
    }
}
